﻿using System;

namespace DIP_Holds
{

    /// <summary>
    /// interface poskytujici tride BussinesLogic pristup k ceskym cenam
    /// </summary>
    public interface ICZKPriceFeeder
    {
        decimal GetPrice();
    }


    /// <summary>
    /// BussinesLogic je nyni zavisla na abstrakci: potrebuje pouze objekt implementujici ICZKPriceFeeder. 
    /// Zavislost na nizsich vrstvach je tak zrusena. DIP plati
    /// </summary>
    public class BussinesLogic
    {

        // private fields
        private ICZKPriceFeeder feeder;
        private decimal dph;


        // constructor
        public BussinesLogic(decimal dph, ICZKPriceFeeder czkFeeder)
        {
            feeder = czkFeeder;
            this.dph = dph + 1;
        }


        // prints prices with DPH
        public void PrintPrices()
        {
            decimal total = 0;
            decimal price;
            while ((price = feeder.GetPrice()) != -1)
            {
                Console.WriteLine("{0}\t{1}", price, price * dph);
                total += price;
            }
            Console.WriteLine("-----------------------------------------");
            Console.WriteLine("{0}\t{1}", total, total * dph);
        }

    }

}
