﻿namespace DIP_Holds
{

    /// <summary>
    /// interface poskytujici tride CurrencyConvertor pristup k cenam (v neurcene mene)
    /// </summary>
    public interface ICommonFeeder
    {
        decimal GetPrice();
    }


    /// <summary>
    /// trida currency convertor muze byt pouzit jako mezivrstva mezi libovolnym feederem a bussines logikou. prevadi libovolnou menu na koruny
    /// implementuje interface ktery vlastni busines logika a pouziva ICommonFeeder, ktery vlastni sam
    /// </summary>
    public class CurrencyConvertor : ICZKPriceFeeder
    {

        // private fields
        private ICommonFeeder feeder;
        private decimal coef;

        // constructor
        public CurrencyConvertor(decimal coef, ICommonFeeder feeder)
        {
            this.coef = coef;
            this.feeder = feeder;
        }

        // get converted price
        public decimal GetPrice()
        {
            decimal d = feeder.GetPrice();
            return (d == -1) ? d : d*coef;
        }

    }

}
