﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DIP_Holds
{

    /// <summary>
    /// Trida ktera generuje ceny v CZK a implementuje i common feeder
    /// </summary>
    public class CZKPriceFeeder : ICZKPriceFeeder, ICommonFeeder
    {

        // private fields
        private decimal[] prices = new decimal[] { 3, 7, 23, 98, 100, 23, 1, 6 };
        private int counter;

        // gets price
        public decimal GetPrice()
        {
            bool stop = counter >= prices.Length;
            return stop ? -1 : prices[counter++];
        }
    }


    /// <summary>
    /// Trida ktera generuje ceny v eurech, a implementuje common feeder
    /// </summary>
    public class EuroPriceFeeder : ICommonFeeder
    {

        // private fields
        private decimal[] prices = new decimal[] { 4, 5, 2, 8, 10, 1};
        private int counter;

        // gets price
        public decimal GetPrice()
        {
            bool stop = counter >= prices.Length;
            return stop ? -1 : prices[counter++];
        }
    }

}
