﻿using System;

namespace DIP_Violation
{

    /// <summary>
    /// BussinesLogic je vysokourovnova trida, ktery v sobe zapouzdruje logiku vypoctu dph. Ceny nacita z tridy CZKPriceFeeder.
    /// BussinesLogic je zavysla na zmenach v nizkourovnove CZKPriceFeeder, a jakakoli zmena feederu si vynuti jeji zmenu. Porusen DIP    
    /// </summary>
    public class BussinesLogic
    {

        // private fields
        private CZKPriceFeeder feeder;
        private decimal dph;


        // constructor
        public BussinesLogic(decimal dph)
        {
            feeder = new CZKPriceFeeder();
            this.dph = dph + 1;
        }


        // prints prices with DPH
        public void PrintPrices()
        {
            decimal total = 0;
            decimal price;
            while ((price = feeder.GetPrice()) != -1)
            {
                Console.WriteLine("{0}\t{1}", price, price * dph);
                total += price;
            }
            Console.WriteLine("-----------------------------------------");
            Console.WriteLine("{0}\t{1}", total, total * dph);
        }

    }

}
