﻿using System;

namespace ISP_Holds
{

    /// <summary>
    /// velke rozhrani IColoredUI bylo podle principu ISP rozdeleno podle toho, kteri klienti ktere metody pouzivaji
    /// </summary>
    public interface IBlueUI
    {

        // metoda pro modreho klienta
        void BlueMethod();      

    }

    /// <summary>
    /// to znamena ze jiz cerveny klient nevidi na modrou metodu
    /// </summary>
    public interface IRedUI
    {
       
        // metoda pro cerveneho klienta
        void RedMethod();

    }


    /// <summary>
    /// a rozsirezi zeleneho rozhrani nezasahne ostatni klienty
    /// </summary>
    public interface IGreenUI
    {      

        // metoda pro zeleneho klienta
        void GreenMethod();

        // metoda pro cerveneho klienta
        void NewGreenMethod();

    }



    /// <summary>
    /// velka trida obsahujici spoustu metod rozsirena o novou zelenou
    /// </summary>
    public class AzureUI : IBlueUI, IGreenUI
    {
        public void BlueMethod()
        {
            Console.WriteLine("BlueMethod");
        }

        public void NewGreenMethod()
        {
            Console.WriteLine("NewGreenMethod");
        }

        public void GreenMethod()
        {
            Console.WriteLine("GreenMethod");
        }
    }



    /// <summary>
    /// ui for red client separated from colorUI
    /// </summary>
    public class RedUI : IRedUI
    {
        public void RedMethod()
        {
            Console.WriteLine("SeparatedRedMethod");
        }
    }

}
