﻿using System;

namespace ISP_Violation
{

    /// <summary>
    /// rozhrani k tride ktera obsahuje spoustu metod, jednotlive metody spolu nejsou svazane a proto je zde porusen ISP:
    /// napr. zeleny klient ma pristup k modre metode a tim padem se musi prispusobit pokud bude chtit modry klient metodu menit
    /// </summary>
    public interface IColoredUI
    {

        // metoda pro modreho klienta
        void BlueMethod();

        // metoda pro cerveneho klienta
        void RedMethod();

        // metoda pro zeleneho klienta
        void GreenMethod();

    }


    /// <summary>
    /// velka trida obsahujici spoustu metod
    /// </summary>
    public class ColoredUI : IColoredUI
    {
        public void BlueMethod()
        {
            Console.WriteLine("BlueMethod");
        }

        public void RedMethod()
        {
            Console.WriteLine("RedMethod");
        }

        public void GreenMethod()
        {
            Console.WriteLine("GreenMethod");
        }
    }

}
