﻿using System;
using OCP_Holds;

namespace OCP_Extension
{

    /// <summary>
    /// Novy modul, ktery lze pouzit bez zasahu do puvodni knihovny
    /// </summary>
    public class Abs : IModule
    {

        // computes absolute value
        public int Compute(int x)
        {
            return (x < 0) ? -x : x;
        }

    }


    /// <summary>
    /// Main entry point
    /// </summary>
    class Program
    {
        static void Main(string[] args)
        {
            ComputingPipeLine pipeline = new ComputingPipeLine();
            pipeline.Modules = new IModule[] {
                new Multiplier(3),                
                new Adder(4),  
                new Abs(),
                new Adder(-4)
            };
            for (int i = -10; i <= 10; i++)
                Console.WriteLine("p({0}) = {1}", i, pipeline.Compute(i));                                             
        }
    }

}
