﻿namespace OCP_Holds
{

    /// <summary>
    /// Interface ktery dovoluje pracovat s moduly abstraktne
    /// </summary>
    public interface IModule
    {
        int Compute(int x);
    }


    /// <summary>
    /// Vlastnost modulu byla abstrahovana do rozhrani IModule, s kterym nyni pracuje trida obecne a dokonce jej sama implementuje. 
    /// Krome implementovanych modulu Multiplier a Adder lze pouzit nove implementace, aniz by bylo nutne zasahovat do knihovny.
    /// </summary>
    public class ComputingPipeLine : IModule
    {

        // modules
        public IModule[] Modules { get; set; }

        // computes result
        public int Compute(int x)
        {
            foreach (IModule module in Modules)            
                x = module.Compute(x);            
            return x;
        }

    }

}
