﻿namespace OCP_Violation
{

    /// <summary>
    /// Trida v sobe uchovava pipeline slozenou z jednoduchych vypocetnich modulu. Obsahuje algoritmus ktery prozene cislo ze vstupu pipelineou
    /// Pouzite moduly jsou omezeny na Multiplier a Adder a v pripade rozsireni o dalsi je treba modifikovat metodu Compute -> Porusen OCP.
    /// </summary>
    public class ComputingPipeLine
    {

        // modules
        public object[] Modules { get; set; }

        // computes result
        public int Compute(int x)
        {
            foreach(object module in Modules)
            {
                if (module is Multiplier)
                    x = ((Multiplier) module).Multiply(x);
                else if (module is Adder)
                    x = ((Adder) module).Add(x);
            }
            return x;
        }

    }

}
