﻿using System;

namespace SPR_Holds
{

    /// <summary>
    /// ConsoleRectangle umi vykreslit obdelnik na konzoli a zaroven pohlidat aby se na ni vlezl. Funkcionalitu geometrickeho obdelniku vsak nenarusuje
    /// </summary>
    public class ConsoleRectangle
    {

        // private fields
        private GeometricRectangle rec;             // geometric representation

        // rectangle setter
        public GeometricRectangle Rectangle
        {
            set 
            { 
                CheckRectangle(value);
                rec = value;
            }
        }

        
        // draws rectangle
        public void Draw()
        {
            Console.SetCursorPosition(rec.X, rec.Y);
            Console.Write(new string('*', rec.Width));
            for (int i = rec.Y + 1; i < rec.Y + rec.Height - 1; i++)
            {
                Console.SetCursorPosition(rec.X, i);
                Console.Write('*');
                Console.SetCursorPosition(rec.X + rec.Width - 1, i);
                Console.Write('*');
            }
            Console.SetCursorPosition(rec.X, rec.Y + rec.Height - 1);
            Console.Write(new string('*', rec.Width));
        }


        // check whether it is able to draw rectangle to console
        private void CheckRectangle(GeometricRectangle rec)
        {
            if(rec.X < 0 || rec.Y < 0 || rec.X + rec.Width > 80 || rec.Y + rec.Height > 25)
                throw new ArgumentOutOfRangeException();
        }

    }

}
