﻿using System;

namespace SRP_Violation
{

    /// <summary>
    /// Trida Rectangle porusuje Single-Responsibility Principle, protoze v sobe uklada informace o geometrii vcetne vypoctu plochy, a zaroven metodu pro vykresleni na konzoli. 
    /// Kdyby nastal pozadavek na restrikci geometrických vlastností tak, aby se obdelnik vzdy vlezl do konzoloveho okna 80 x 25, 
    /// aplikace které pouzivaji pouze geometrické prvky tridy a nepocitaji s restrikcemi by zacli hazet chyby.
    /// </summary>
    public class Rectangle
    {

        // public properties
        public int X { get; set; }
        public int Y { get; set; }
        public int Width { get; set; }
        public int Height { get; set; }


        // returns area of rectangle
        public int GetArea()
        {
            return Width*Height;
        }


        // draws rectangle
        public void Draw()
        {
            Console.SetCursorPosition(X, Y);
            Console.Write(new string('*', Width));
            for (int i = Y + 1; i < Y + Height - 1; i++)
            {
                Console.SetCursorPosition(X, i);
                Console.Write('*');
                Console.SetCursorPosition(X + Width - 1, i);
                Console.Write('*');
            }
            Console.SetCursorPosition(X, Y + Height - 1);
            Console.Write(new string('*', Width));
        }

    }

}
